"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LetOperator = void 0;
const lit_html_1 = require("@rxdi/lit-html");
/**
 * @customElement r-let
 */
let LetOperator = class LetOperator extends lit_html_1.LitElement {
    constructor() {
        super(...arguments);
        this.data = [];
        this.item = (v) => (0, lit_html_1.html) ` ${v} `;
    }
    OnUpdateFirst() {
        if (!this.isObservable(this.data)) {
            this.parentElement.parentNode.insertBefore(this.shadowRoot, this.parentElement.nextSibling);
        }
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    normalizeArray(state) {
        if (!state || typeof state === 'string') {
            return [];
        }
        if (typeof state === 'number') {
            return Array.from(Array(state), (v, i) => i);
        }
        /* https://javascript.info/map-set */
        if (state instanceof Map || state instanceof Set) {
            return [...state.entries()];
        }
        if (!Array.isArray(state)) {
            return Object.entries(state);
        }
        return state;
    }
    isObservable(value) {
        return (value && this.isFunction(value.lift) && this.isFunction(value.subscribe));
    }
    isFunction(value) {
        return typeof value === 'function';
    }
};
exports.LetOperator = LetOperator;
__decorate([
    (0, lit_html_1.property)({ type: Array }),
    __metadata("design:type", Object)
], LetOperator.prototype, "data", void 0);
__decorate([
    (0, lit_html_1.property)({ type: Object }),
    __metadata("design:type", Object)
], LetOperator.prototype, "item", void 0);
exports.LetOperator = LetOperator = __decorate([
    (0, lit_html_1.Component)({
        selector: 'r-let',
        template() {
            return (0, lit_html_1.html) `
      ${this.isObservable(this.data)
                ? (0, lit_html_1.html) `
            <r-renderer
              .options=${{
                    state: this.data,
                    render: (state, set, shadowRoot) => {
                        this.parentElement.parentNode.insertBefore(shadowRoot, this.parentElement.nextSibling);
                        return (0, lit_html_1.html) `${this.normalizeArray(state).map(this.item)}`;
                    },
                }}
            ></r-renderer>
          `
                : this.normalizeArray(this.data).map(this.item)}
    `;
        },
    })
], LetOperator);
//# sourceMappingURL=let.js.map